package me.ChrisvA.MinecartExtra;

import org.bukkit.World;

public class MinecartCollector {

	//Last time when the minecart collect items 
	protected long lastCollect;
	// How often the cart should collect Items
	protected int limit;
	protected long insertTime;
	private boolean playerCart;
	private World cartWorld;
	
	
	public MinecartCollector(World world, int limit, boolean playercart){
		this.init(world, limit, playercart);
	}
	
	public MinecartCollector(World world, int limit){
		this.init(world, limit, false);
	}
	
	private void init(World world, int limit, boolean playercart) {
		this.limit = limit;
		cartWorld = world;
		this.lastCollect = cartWorld.getFullTime();
		this.insertTime = cartWorld.getFullTime();
		this.playerCart = playercart;
	}

	// Check if it's time to collect items
	public boolean CollectionTime (){
		if (cartWorld.getFullTime()  - lastCollect >= limit){
			lastCollect = cartWorld.getFullTime();
			return true;
		}else{
			return false;
		}
	}
	
	public long getNoMoveTime(){
		return cartWorld.getFullTime() - lastCollect; 
	}
	
	public long getLastMovement(){
		return lastCollect;
	}
	
	public boolean isPlayerCart(){
		return playerCart;
	}
	
	public long getLifeTime(){
		return (cartWorld.getFullTime()  - insertTime);
	}
	
}
