package me.ChrisvA.MinecartExtra;

import java.io.File;

public class MinecartExtraConfig {

	private MinecartExtra plugin;
	
	private double collectHradius = 4.0;
	private double collectVradius = 4.0;
	private int collectRate = 20;
	private int collectCleanup = 1000;
	private int collectCheckTimeout = 100;
	private int collectTimeplayers = 20;
	private int collectTimeCollection = 12;
	private boolean collectAutodetect = true;
	private String lang = "en";
	private boolean useEconomy = false;
	private double priceCollectCreate = 10.0;
	
	public MinecartExtraConfig(MinecartExtra plugin){
		this.plugin = plugin;
		
		collectHradius = this.plugin.getConfig().getDouble("collect.hradius");
		collectVradius = this.plugin.getConfig().getDouble("collect.vradius");
		collectRate = this.plugin.getConfig().getInt("collect.rate");
		collectCleanup = this.plugin.getConfig().getInt("collect.cleanup");
		collectCheckTimeout = this.plugin.getConfig().getInt("collect.checktimeout");
		collectTimeplayers = this.plugin.getConfig().getInt("collect.timeplayers");
		collectTimeCollection = this.plugin.getConfig().getInt("collect.timecollection");
		collectAutodetect = this.plugin.getConfig().getBoolean("collect.autodetect");
		useEconomy = this.plugin.getConfig().getBoolean("economy.use");
		priceCollectCreate =  this.plugin.getConfig().getDouble("economy.price.collectcreate");
		
		lang = this.plugin.getConfig().getString("lang");
		
		File f = new File("plugins/MinecartExtra/config.yml");
		if (!f.exists()){
			this.plugin.saveDefaultConfig();
			//this.plugin.saveConfig()
		}
	}
	// save the config to store new settings on the disk
	//TODO File isn't completly saved.
	/*public void saveConfig(){
		this.plugin.saveConfig();
	}*/

	/**
	 * @param collectCleanup the collectCleanup to set
	 */
	public void setCollectCleanup(int collectCleanup) {
		this.collectCleanup = collectCleanup;
		this.plugin.getConfig().set("collect.cleanup", collectCleanup);
	}

	/**
	 * @return the collectCleanup
	 */
	public int getCollectCleanup() {
		return collectCleanup;
	}

	/**
	 * @param collectRate the collectRate to set
	 */
	public void setCollectRate(int collectRate) {
		this.collectRate = collectRate;
		this.plugin.getConfig().set("collect.rate", collectRate);
	}

	/**
	 * @return the collectRate
	 */
	public int getCollectRate() {
		return collectRate;
	}

	/**
	 * @param collectVradius the collectVradius to set
	 */
	public void setCollectVradius(double collectVradius) {
		this.collectVradius = collectVradius;
		this.plugin.getConfig().set("collect.vradius", collectVradius);
	}

	/**
	 * @return the collectVradius
	 */
	public double getCollectVradius() {
		return collectVradius;
	}

	/**
	 * @param collectHradius the collectHradius to set
	 */
	public void setCollectHradius(double collectHradius) {
		this.collectHradius = collectHradius;
		this.plugin.getConfig().set("collect.hradius", collectHradius);
	}

	/**
	 * @return the collectHradius
	 */
	public double getCollectHradius() {
		return collectHradius;
	}

	/**
	 * @param collectTimeplayers the collectTimeplayers to set
	 */
	public void setCollectTimeplayers(int collectTimeplayers) {
		this.collectTimeplayers = collectTimeplayers;
		this.plugin.getConfig().set("collect.timeplayers", collectTimeplayers);
	}

	/**
	 * @return the collectTimeplayers
	 */
	public int getCollectTimeplayers() {
		return collectTimeplayers;
	}

	/**
	 * @param collectAutodetect the collectAutodetect to set
	 */
	public void setCollectAutodetect(boolean collectAutodetect) {
		this.collectAutodetect = collectAutodetect;
		this.plugin.getConfig().set("collect.autodetect", collectAutodetect);
	}

	/**
	 * @return the collectAutodetect
	 */
	public boolean isCollectAutodetect() {
		return collectAutodetect;
	}

	/**
	 * @param collectTimeCollection the collectTimeCollection to set
	 */
	public void setCollectTimeCollection(int collectTimeCollection) {
		this.collectTimeCollection = collectTimeCollection;
		this.plugin.getConfig().set("collect.timecollection", collectTimeCollection);
	}

	/**
	 * @return the collectTimeCollection
	 */
	public int getCollectTimeCollection() {
		return collectTimeCollection;
	}

	/**
	 * @param lang the lang to set
	 */
	public void setLang(String lang) {
		this.plugin.getConfig().set("lang", lang);
		this.lang = lang;
	}

	/**
	 * @return the lang
	 */
	public String getLang() {
		return lang;
	}

	/**
	 * @param useEconomy the useEconomy to set
	 */
	public void setUseEconomy(boolean useEconomy) {
		this.useEconomy = useEconomy;
		this.plugin.getConfig().set("economy.use", useEconomy);
	}

	/**
	 * @return the useEconomy
	 */
	public boolean isUseEconomy() {
		return useEconomy;
	}

	/**
	 * @param priceCollectCreate the priceCollectCreate to set
	 */
	public void setPriceCollectCreate(double priceCollectCreate) {
		this.priceCollectCreate = priceCollectCreate;
		this.plugin.getConfig().set("economy.price.collectcreate", priceCollectCreate);
	}

	/**
	 * @return the priceCollectCreate
	 */
	public double getPriceCollectCreate() {
		return priceCollectCreate;
	}

	/**
	 * @param collectCheckTimeout the collectCheckTimeout to set
	 */
	public void setCollectCheckTimeout(int collectCheckTimeout) {
		this.collectCheckTimeout = collectCheckTimeout;
		this.plugin.getConfig().set("collect.checktimeout", collectCheckTimeout);
	}

	/**
	 * @return the collectCheckTimeout
	 */
	public int getCollectCheckTimeout() {
		return collectCheckTimeout;
	}
	
}
